'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var classnames = require('classnames');
var typographyColorTokens = require('@highlight-ui/tokens/dist/typography/colors.json');
var utilsCommons = require('@highlight-ui/utils-commons');
var typographyFontFamilyTokens = require('@highlight-ui/tokens/dist/typography/fontFamilies.json');
var typographyFontSizeTokens = require('@highlight-ui/tokens/dist/typography/fontSizes.json');
var typographyFontWeightTokens = require('@highlight-ui/tokens/dist/typography/fontWeights.json');
var typographyTextCaseTokens = require('@highlight-ui/tokens/dist/typography/textCase.json');
var typographyTextDecorationTokens = require('@highlight-ui/tokens/dist/typography/textDecoration.json');
var typographyLetterSpacingTokens = require('@highlight-ui/tokens/dist/typography/letterSpacing.json');
var typographyLineHeightTokens = require('@highlight-ui/tokens/dist/typography/lineHeights.json');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);
var typographyColorTokens__default = /*#__PURE__*/_interopDefaultLegacy(typographyColorTokens);
var typographyFontFamilyTokens__default = /*#__PURE__*/_interopDefaultLegacy(typographyFontFamilyTokens);
var typographyFontSizeTokens__default = /*#__PURE__*/_interopDefaultLegacy(typographyFontSizeTokens);
var typographyFontWeightTokens__default = /*#__PURE__*/_interopDefaultLegacy(typographyFontWeightTokens);
var typographyTextCaseTokens__default = /*#__PURE__*/_interopDefaultLegacy(typographyTextCaseTokens);
var typographyTextDecorationTokens__default = /*#__PURE__*/_interopDefaultLegacy(typographyTextDecorationTokens);
var typographyLetterSpacingTokens__default = /*#__PURE__*/_interopDefaultLegacy(typographyLetterSpacingTokens);
var typographyLineHeightTokens__default = /*#__PURE__*/_interopDefaultLegacy(typographyLineHeightTokens);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

var styles$1 = {"typography":"DeprecatedTypography-module__3E6EAawk__v4-1-5","heading-1":"DeprecatedTypography-module__1cmm-QOZ__v4-1-5","heading-2":"DeprecatedTypography-module__3oLEZkte__v4-1-5","heading-3":"DeprecatedTypography-module__3zaQMR1l__v4-1-5","heading-4":"DeprecatedTypography-module__1fzg0rQx__v4-1-5","subtitle-1":"DeprecatedTypography-module__3yxgC0G0__v4-1-5","subtitle-2":"DeprecatedTypography-module__16DAAehl__v4-1-5","subtitle-3":"DeprecatedTypography-module__WFLyAfbf__v4-1-5","subtitle-4":"DeprecatedTypography-module__2YegmjwR__v4-1-5","body-1":"DeprecatedTypography-module__ZJz2w_19__v4-1-5","button-1":"DeprecatedTypography-module__2FT46T2r__v4-1-5","caption-1":"DeprecatedTypography-module__j9liMIKk__v4-1-5","caption-2":"DeprecatedTypography-module__1NkGiQMd__v4-1-5","overline-1":"DeprecatedTypography-module__OIp7evSZ__v4-1-5"};

var variantMapping = {
    'heading-1': 'h1',
    'heading-2': 'h2',
    'heading-3': 'h3',
    'heading-4': 'h4',
    'subtitle-1': 'h6',
    'subtitle-2': 'h6',
    'subtitle-3': 'h6',
    'subtitle-4': 'h6',
    'body-1': 'p',
    'button-1': 'span',
    'caption-1': 'span',
    'caption-2': 'span',
    'overline-1': 'span',
};
var DeprecatedTypographyWithRef = function (_a, ref) {
    var children = _a.children, className = _a.className, component = _a.component, _b = _a.variant, variant = _b === void 0 ? 'body-1' : _b, color = _a.color, style = _a.style, otherProps = __rest(_a, ["children", "className", "component", "variant", "color", "style"]);
    var tag = component || variantMapping[variant];
    return React__default["default"].createElement(tag, __assign(__assign({}, otherProps), { ref: ref, style: __assign({ color: color && typographyColorTokens__default["default"][color] }, style), className: classnames__default["default"](styles$1[variant], className, styles$1.typography) }), children);
};
DeprecatedTypographyWithRef.displayName = 'DeprecatedTypography';
var DeprecatedTypography = React__default["default"].forwardRef(DeprecatedTypographyWithRef);

var styles = {"heading-xsmall":"TokenisedTypography-module__1YsIcMxi__v4-1-5","heading-small":"TokenisedTypography-module__2Tjhif8O__v4-1-5","heading-medium":"TokenisedTypography-module__39Wv6qhS__v4-1-5","heading-large":"TokenisedTypography-module__mu8VVaPP__v4-1-5","heading-xlarge":"TokenisedTypography-module__3znEX76x__v4-1-5","heading-2xl":"TokenisedTypography-module__2032bH2g__v4-1-5","body-small":"TokenisedTypography-module__Awx6ASqb__v4-1-5","body-base":"TokenisedTypography-module__2hWZvNqG__v4-1-5","body-large":"TokenisedTypography-module__3fKKs0sb__v4-1-5","body-strong-small":"TokenisedTypography-module__2BRtEBGE__v4-1-5","body-strong-base":"TokenisedTypography-module__26Ps5BFu__v4-1-5","body-strong-large":"TokenisedTypography-module__2v82cFI6__v4-1-5","page-heading":"TokenisedTypography-module__3-VAPTtK__v4-1-5","button":"TokenisedTypography-module__1xTqu8MO__v4-1-5","form-label":"TokenisedTypography-module__3nPzt67d__v4-1-5","caption":"TokenisedTypography-module__1v75Mc4c__v4-1-5","text-link-default":"TokenisedTypography-module__3OtUZ7z0__v4-1-5","text-link-hover":"TokenisedTypography-module__1yJbavt8__v4-1-5","table-data-regular":"TokenisedTypography-module__1XzdQRu2__v4-1-5","table-data-bold":"TokenisedTypography-module__2TM0sssh__v4-1-5"};

var TokenisedTypographyWithRef = function (_a, ref) {
    var children = _a.children, className = _a.className, _b = _a.component, component = _b === void 0 ? 'p' : _b, _c = _a.token, token = _c === void 0 ? 'body-base' : _c, color = _a.color, style = _a.style, fontFamily = _a.fontFamily, fontSize = _a.fontSize, fontWeight = _a.fontWeight, letterSpacing = _a.letterSpacing, lineHeight = _a.lineHeight, textTransform = _a.textTransform, textDecoration = _a.textDecoration, metadata = _a.metadata, otherProps = __rest(_a, ["children", "className", "component", "token", "color", "style", "fontFamily", "fontSize", "fontWeight", "letterSpacing", "lineHeight", "textTransform", "textDecoration", "metadata"]);
    return React__default["default"].createElement(component, __assign(__assign(__assign({}, otherProps), utilsCommons.parseMetadata(metadata)), { ref: ref, style: __assign({ color: color && typographyColorTokens__default["default"][color], fontFamily: fontFamily && typographyFontFamilyTokens__default["default"][fontFamily], fontSize: fontSize && typographyFontSizeTokens__default["default"][fontSize], fontWeight: fontWeight && typographyFontWeightTokens__default["default"][fontWeight], letterSpacing: letterSpacing && typographyLetterSpacingTokens__default["default"][letterSpacing], lineHeight: lineHeight && typographyLineHeightTokens__default["default"][lineHeight], textTransform: textTransform && typographyTextCaseTokens__default["default"][textTransform], textDecoration: textDecoration && typographyTextDecorationTokens__default["default"][textDecoration] }, style), className: classnames__default["default"](styles[token], className) }), children);
};
TokenisedTypographyWithRef.displayName = 'TokenisedTypography';
var TokenisedTypography = React__default["default"].forwardRef(TokenisedTypographyWithRef);

var TypographyWithRef = function (_a, ref) {
    var variant = _a.variant, token = _a.token, fontFamily = _a.fontFamily, fontSize = _a.fontSize, fontWeight = _a.fontWeight, letterSpacing = _a.letterSpacing, lineHeight = _a.lineHeight, textTransform = _a.textTransform, textDecoration = _a.textDecoration, otherProps = __rest(_a, ["variant", "token", "fontFamily", "fontSize", "fontWeight", "letterSpacing", "lineHeight", "textTransform", "textDecoration"]);
    return token ? (React__default["default"].createElement(TokenisedTypography, __assign({ ref: ref, token: token, fontFamily: fontFamily, fontSize: fontSize, fontWeight: fontWeight, letterSpacing: letterSpacing, lineHeight: lineHeight, textTransform: textTransform, textDecoration: textDecoration }, otherProps))) : (React__default["default"].createElement(DeprecatedTypography, __assign({ ref: ref, variant: variant }, otherProps)));
};
TypographyWithRef.displayName = 'Typography';
var Typography = React__default["default"].forwardRef(TypographyWithRef);

exports.DeprecatedTypography = DeprecatedTypography;
exports.TokenisedTypography = TokenisedTypography;
exports.Typography = Typography;
//# sourceMappingURL=index.js.map
